#!/bin/sh 
#
# 
#
#
#********************************************************************************
#* COPYRIGHT (C) 2009  by RSA Security Inc.
#*	---ALL RIGHTS RESERVED---
#********************************************************************************
#

############################################################
# Set default values and commands for the shell script.
############################################################
clear

OS_NAME=`uname`
if [ $OS_NAME = "Linux" ] ; then
        if [ `uname -r | cut -f 1 -d '-'` = "2.6.18" ] ; then
		if [ `getconf LONG_BIT` = "32" ] ; then
			OS_NAME=LinuxAS5_1_32
		else
			OS_NAME=LinuxAS5_1_64
		fi
        else
                OS_NAME=LinuxAS4
        fi
fi
if [ $OS_NAME = "SunOS" ] ; then
	ARCH=`uname -p`
	if [ "$ARCH" = "i386" ] ; then
		if [ `/usr/bin/isainfo -kv | cut -f 1 -d '-'` = "32" ] ; then
			OS_NAME=SunOS_x86_32
		else
			OS_NAME=SunOS_x86_64
		fi
        else
		if [ `/usr/bin/isainfo -kv | cut -f 1 -d '-'` = "64" ] ; then
			OS_NAME=SunOS_SPARC_64
		else
			OS_NAME=SunOS
		fi
	fi
fi

make -f Makefile.$OS_NAME
