<%@ page language = "java" %>

<%@ page import="com.rsa.cookieapi.RSACookieAPI" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>

<%!
    public RSACookieAPI rsacookieapi;

    public int encrypt;
	
    public static String HTMLEntityEncode( String s )
    {
       StringBuffer buf = new StringBuffer();
       int len = (s == null ? -1 : s.length());

       for ( int i = 0; i < len; i++ )
       {
           char c = s.charAt( i );
           if ( c>='a' && c<='z' || c>='A' && c<='Z' || c>='0' && c<='9' )
           {
               buf.append( c );
           }
           else
           {
               buf.append( "&#" + (int)c + ";" );
           }
       }
       return buf.toString();
   }

%>

<HTML>
<HEAD><title>Test page for Cookie API</title></head>
<BODY bgcolor="white" topmargin="10" leftmargin="10">

<!-- Display Header -->

        <font size="4" face="Arial, Helvetica">
        <b>RSA Cookie API Sample</b></font><br>

        <hr size="1" color="#000000">

    <%
        try
        {
            rsacookieapi = new RSACookieAPI(request);
        }
        catch (Exception ex)
        {
            System.out.println("Couldn't create RSACookieAPI class." + ex.getMessage());
        }
    %>
	<%

    (response.getWriter()).println("<p align=right><a href="+rsacookieapi.RSAGetWebIDURL()+"?logoff?RSArand="+rsacookieapi.RSAGetCSRFToken()+">Logoff</a></p>");
	%>
	
	
    Hello <%=rsacookieapi.RSAGetUserName() %>.<p>

    Your Default Shell Field is set to: <%=rsacookieapi.RSAGetShellField() %>.<p>

    <%
        String queryString = request.getQueryString();
   
        if(queryString != null)
        {
            String header = "";
            String cmd = request.getParameter("cmd");
            if(cmd == null)
            {
                cmd = "";
            }
            String gettag = request.getParameter("gettag");
            if(gettag == null)
            {
                gettag = "";
            }
            String tag1 = request.getParameter("tag1");
            String data1 = request.getParameter("data1");
            if(data1 == null)
            {
                data1 = "";
            }
            String tag2 = request.getParameter("tag2");
            String data2 = request.getParameter("data2");
            if(data2 == null)
            {
                data2 = "";
            }
            String tag3 = request.getParameter("tag3");
            String data3 = request.getParameter("data3");
            if(data3 == null)
            {
                data3 = "";
            }
            String enc = request.getParameter("encrypt");
            if(enc == null)
            {
                enc = "off";
            }

            if( enc.equals("on") )
            {
                encrypt = 1;
            }
            else
            {
                encrypt = 0;
            }

            if( cmd.equals("AddData") )
            {
                boolean flag = false;
                boolean firsttime = true;
                String cookieheader = "";
                if( (tag1.equals("") == false) && (tag1 != null) )
                {
                    header = rsacookieapi.RSASetTagField(tag1,
                                                         data1,
                                                         encrypt);

                    if( (header.equals("") ) && 
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Failed to set data tag " + HTMLEntityEncode(tag1) + "</strong>");
                    }
                    else
                    {
                        flag |= true;
                        firsttime = false;

                        //We have a new cookie header, save it.
                        cookieheader = header;
                        (response.getWriter() ).println( "<strong> Data tag1: " +
                                                          HTMLEntityEncode(tag1) +
                                                         " added successfully </strong>");
                    }
                }//end if tag1

                //Try to set the second tag if there is one
                if( (tag2.equals("") == false) && (tag2 != null) )
                {
                    if(firsttime)
                    {
                        header = rsacookieapi.RSASetTagField(tag2,
                                                             data2,
                                                             encrypt);
                    }

                    else
                    {
                        header = rsacookieapi.RSASetTagField(header,
                                                             tag2,
                                                             data2,
                                                             encrypt);
                    }

                    if( (header.equals("") ) && 
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Failed to set data tag " + HTMLEntityEncode(tag2) + "</strong>");
                    }
                    else
                    {
                        firsttime = false;

                        //We have a new cookie header, save it.
                        cookieheader = header;
                        flag |= true;
                        (response.getWriter() ).println( "<strong> Data tag: " +
                                                          HTMLEntityEncode(tag2) +
                                                         " added successfully </strong>");
                    }

                } //end if tag2

                //Now try to set the third flag
                if( (tag3.equals("") == false) && (tag3 != null ) )
                {
                    if(firsttime)
                    {
                        header = rsacookieapi.RSASetTagField(tag3,
                                                             data3,
                                                             encrypt);
                    }
                    else
                    {
                        header = rsacookieapi.RSASetTagField(header,
                                                             tag3,
                                                             data3,
                                                             encrypt);
                    }

                    if( (header.equals("") ) &&
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Failed to set data tag " + HTMLEntityEncode(tag3) + "</strong>");
                    }
                    else
                    {
                        flag |= true;

                        //We have a new cookie header, save it.
                        cookieheader = header;
                        (response.getWriter() ).println( "<strong> Data tag: " +
                                                          HTMLEntityEncode(tag3) +
                                                         " added successfully </strong>");
                    }

                } //end if tag3

                //If any of the tags have been set then set the cookie header
                if(flag != false)
                {
                    response.addHeader("set-cookie", cookieheader);

                    (response.getWriter() ).println("<strong>One or more tags have been added successfully</strong><p>New cookie: " + HTMLEntityEncode(cookieheader) );
                }
            }//if addtag

            else if( cmd.equals("GetData") )
            {
                header = rsacookieapi.RSAGetTagField(gettag,
                                                     encrypt);

                if( (header.equals("") ) && 
                    (rsacookieapi.RSAGetLastError() != 0) )
                {
                    (response.getWriter() ).println( "<strong>Data tag " + HTMLEntityEncode(gettag) + " not found!</strong>");
                }
                else
                {
                    (response.getWriter() ).println("Data tag " + HTMLEntityEncode(gettag) + " contents: " + HTMLEntityEncode(header) );
                }
            }

            else if( cmd.equals("DelData") )
            {
                boolean flag = false;
                boolean firsttime = true;
                String cookieheader = "";
                if( (tag1.equals("") == false) && (tag1 != null) )
                {
                    header = rsacookieapi.RSADeleteTagField(tag1);
                    if( (header.equals("") ) && 
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Data tag " + HTMLEntityEncode(tag1) + " not found!</strong>");
                    }
                    else
                    {
                        flag |= true;
                        firsttime = false;

                        //We have a new cookie header, save it
                        cookieheader = header;
                        (response.getWriter() ).println( "<strong> Data tag: " +
                                                          HTMLEntityEncode(tag1) +
                                                         " deleted successfully </strong>");
                    }
                } //end if tag1
                if( (tag2.equals("") == false) && (tag2 != null) )
                {
                    if(firsttime)
                    {
                        header = rsacookieapi.RSADeleteTagField(tag2);
                    }
                    else
                    {
                        header = rsacookieapi.RSADeleteTagField(header,tag2);
                    }
                    if( (header.equals("") ) && 
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Data tag " + HTMLEntityEncode(tag2) + " not found!</strong>");
                    }
                    else
                    {
                        flag |= true;

                        //We have a new cookie header, save it
                        cookieheader = header;
                        (response.getWriter() ).println( "<strong> Data tag: " +
                                                          HTMLEntityEncode(tag2) +
                                                         " deleted successfully </strong>");
                    }
                } //end if tag2
                if( (tag3.equals("") == false) && (tag3 != null) )
                {
                    if(firsttime)
                    {
                        header = rsacookieapi.RSADeleteTagField(tag3);
                    }
                    else
                    {
                        header = rsacookieapi.RSADeleteTagField(header,tag3);
                    }
                    if( (header.equals("") ) && 
                        (rsacookieapi.RSAGetLastError() != 0) )
                    {
                        flag |= false;
                        (response.getWriter() ).println( "<strong>Data tag " + HTMLEntityEncode(tag3) + " not found!</strong>");
                    }
                    else
                    {
                        flag |= true;

                        //We have a new cookie header, save it
                        cookieheader = header;
                        (response.getWriter() ).println( "<strong> Data tag: " +
                                                          HTMLEntityEncode(tag3) +
                                                         " deleted successfully </strong>");
                    }
                } //end if tag3
                if(flag != false)
                {
                    response.addHeader("set-cookie", cookieheader);

                    (response.getWriter() ).println("<strong>One or more tags have been deleted successfully</strong><p>New cookie: " + HTMLEntityEncode(cookieheader) );
                }
            }
        }
   %>

   <%    rsacookieapi = null; %>

   <hr> Select one of the following options.<hr>

        <form action=sample.jsp>
        <input type=hidden name=cmd value=AddData>
        <h2>Add/Set Data</h2> Tag1: <input type=text name=tag1>
        Data1: <input type=text name=data1>

        <h2> </h2>
        Tag2: <input type=text name=tag2>
        Data2: <input type=text name=data2>

        <h2> </h2>
        Tag3: <input type=text name=tag3>
        Data3: <input type=text name=data3>

        <h2> </h2>
        Encrypted: <input type=checkbox name=encrypt><p>

        <input type=submit>
        </form><p>

        <form action=sample.jsp id=form1 name=form1>
        <input type=hidden name=cmd value=GetData>
        <h2>Get Data</h2> Tag: <input type=text name=gettag>
        Encrypted: <input type=checkbox name=encrypt><p>
        <input type=submit>
        </form><p>

        <form action=sample.jsp id=form2 name=form2>
        <input type=hidden name=cmd value=DelData>
        <h2>Delete Data</h2> Tag1: <input type=text name=tag1>
        Tag2: <input type=text name=tag2>
        Tag3: <input type=text name=tag3><p>
        <input type=submit>
        </form><p>

</body>
</html>

