#!/usr/bin/perl

#####################################################################
# This script displays the contents of a HTTP_COOKIE
#####################################################################

$form_data = $ENV{'QUERY_STRING'};
@pairs=split(/&/,$form_data);
foreach $item(@pairs){
   ($key,$content)=split(/=/,$item,2);
#   $content=~tr/+/ /;
   $content=~ s/%(..)/pack("c",hex($1))/ge;
   $fields{$key}=$content;
}

$nickname = $fields{'nickname'};
$data = $fields{'data'};
$Cookie = $ENV{'HTTP_COOKIE'};

# Get the CSRF Token from cookie
$CSRFToken = `./rsacookie -g -CSRFToken`;
$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Get CSRF Token field failed</font><br>";	
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}

# Get WebID URL from settings.
$WebIDURL = `./rsacookie -g -webIdURL`;
$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Get WebIDURL field failed</font><br>";	
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}

print "Content-type: text/html\n\n";
print "<html>";
print "<title>Cookie Sample</title>\n";

print "<body>";
print "<p align=right><a href=$WebIDURL?logoff?RSArand=$CSRFToken>Logoff</a></p>";
print "<br>$UserName<br>";
print "<br>Cookies = $Cookie<br>";

print "</body></html>";
